#import <Cocoa/Cocoa.h>


@interface DWTableColumn : NSTableColumn 
{
    @public
    unsigned flags;
    id menuTitle;

    SEL sel;
    SEL sortSel;

    IMP imp;
    IMP sortImp;
    
    void* comparator;
    SEL primary;
    SEL secondary;
    
    /* header view cache */
    
    NSImage* image;
    NSSize size;
    
    NSImage* columnImage;
}

- (void) shouldResetCachedImage: (id) sender;

- (void) setFlags: (unsigned) theValue;
- (void) setMenuTitle: (id) theValue;
- (void) setSelector: (SEL) theSelector;
- (void) setSortSelector: (SEL) theSelector;
- (void) setComparator: (void*) theComparator;
- (void) setPrimary: (SEL) theSelector;
- (void) setSecondary: (SEL) theSelector;

- (id) menuTitle;

@end